<?php

  //OK - this processes the address and requests a forecast from OpenWeatherMap
  
  if ($wantsproperties == true)
  {
	  $addressbits = explode(':',$fetchaddress);
	  $apikey = $addressbits[0];
	  $cc = $addressbits[1];
	  
	  //print_r($fetchlookup);
	  if (isset($fetchlookup['address']))
		$addr = $fetchlookup['address'];
	  else
	  {
		if (isset($fetchlookup['longitude']))
		{
			$lat = $fetchlookup['latitude'];
			$lon = $fetchlookup['longitude'];
			if ($lat != "^")
				$gotit = true;
		}
		else
			$addr = $fetchlookup['text'];
	  }
	  if (isset($addr))
	  {
		  $addressbreakdown = explode(',',$addr);
		  
		  $indx = count($addressbreakdown)-1;
		  if (count($addressbreakdown) > 2)
		  {
			$indx--;
		  }
		  $gotit = true;
		  
		  while ($indx > -1)
		  {
			if (is_numeric($addressbreakdown[$indx][0]))
			{	
				$indx--;
				break;
			}
			if (is_numeric($addressbreakdown[$indx][count($addressbreakdown[$indx])-1]))
			{
				$indx--;
				break;
			}
			if ($addressbreakdown[$indx] == strtoupper($addressbreakdown[$indx]))
			{
				$indx--;
				break;
			}
		  }
	  }
	  
	  if(isset($gotit))
	  {
		//Perform the search....
		
		$qry = "";
		if (isset($lon))
		{
			$qry = 'lat='.$lat.'&lon='.$lon;
		}
		else
		{
			$qry = 'q='.urlencode(trim($addressbreakdown[$indx])).','.$cc;
		}
		
		$ch = curl_init();
		$timeout = 5;
		$url = 'http://api.openweathermap.org/data/2.5/weather?'.$qry.'&apikey='.$apikey;
		//echo 'Calling URL '.$url;
		//exit;
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$data = curl_exec($ch);
		curl_close($ch);
		
		$parsed = json_decode($data);
		
		//print_r($parsed);
		//exit;
		
		$row = array();
		$row['name'] = 'Temperature';
		$row['type'] = 'MEASUREMENT';
		$row['value'] = array();
		$row['value']['measurement'] = $parsed->main->temp - 273.15;
		$row['value']['units'] = ' Deg C';
		$row['value']['live'] = $row['value']['measurement'].$row['value']['units'];
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$fetchprops[] = $row;
		
		$row = array();
		$row['name'] = 'Barometric Pressure';
		$row['type'] = 'MEASUREMENT';
		$row['value'] = array();
		$row['value']['measurement'] = $parsed->main->pressure;
		$row['value']['units'] = ' Pa';
		$row['value']['live'] = $row['value']['measurement'].$row['value']['units'];
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$fetchprops[] = $row;
		
		$row = array();
		$row['name'] = 'Humidity';
		$row['type'] = 'MEASUREMENT';
		$row['value'] = array();
		$row['value']['measurement'] = $parsed->main->humidity;
		$row['value']['units'] = '%';
		$row['value']['live'] = $row['value']['measurement'].$row['value']['units'];
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$fetchprops[] = $row;
		
		$row = array();
		$row['name'] = 'Wind Speed';
		$row['type'] = 'MEASUREMENT';
		$row['value'] = array();
		$row['value']['measurement'] = $parsed->wind->speed;
		$row['value']['units'] = 'm/s';
		$row['value']['live'] = $row['value']['measurement'].$row['value']['units'];
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$fetchprops[] = $row;
		
		$row = array();
		$row['name'] = 'Wind Direction';
		$row['type'] = 'MEASUREMENT';
		$row['value'] = array();
		$row['value']['measurement'] = $parsed->wind->deg;
		$row['value']['units'] = ' degrees';
		$row['value']['live'] = $row['value']['measurement'].$row['value']['units'];
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$fetchprops[] = $row;
		
		$row = array();
		$row['name'] = 'Forecast';
		$row['type'] = 'FETCHPAGE';
		$row['value'] = array();
		$row['value']['url'] = 'http://www.openweathermap.org/city/'.$parsed->id;
		$row['value']['character'] = 'fa-circle';
		$fetchprops[] = $row;
	  }
	}
?>